-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "DS_CycleOffset"

-- **************************************************
-- General information about this script
-- **************************************************

DS_CycleOffset = {}
function DS_CycleOffset:Name()
	return "DS_CycleOffset"
end

function DS_CycleOffset:Version()
	return "0.1"
end

function DS_CycleOffset:Description()
	return "Offset a cycle to move a walkcycle"
end

function DS_CycleOffset:Creator()
	return "dauid.com"
end

function DS_CycleOffset:UILabel()
	return("DS Cycle Offset")
end
-- **************************************************
-- Recurring values
-- **************************************************
DS_CycleOffset.doLayer = false 
DS_CycleOffset.doBone = true
DS_CycleOffset.LoopTimes = 10
DS_CycleOffset.LastInterp = 1

--************************menu
local DS_Dialog = {}

DS_Dialog.UPDATE = MOHO.MSG_BASE

function DS_Dialog:new(moho)
	local d = LM.GUI.SimpleDialog("Settings", DS_Dialog)
	local l = d:GetLayout()

	d.moho = moho
	l:PushH()
		l:PushV()
	l:AddChild(LM.GUI.StaticText("Loop this many times: "))
	l:Pop()
		l:PushV()
	d.loopTimes = LM.GUI.TextControl(0, "0.0000", DS_Dialog.UPDATE, LM.GUI.FIELD_UINT)
	d.loopTimes:SetConstantMessages(true)
	l:AddChild(d.loopTimes)
	l:Pop()
	l:Pop()

	boneBox = LM.GUI.RadioButton("Cycle selected bones position")
	l:AddChild(boneBox, LM.GUI.ALIGN_LEFT)
	--d.boneBox:SetValue(DS_CycleOffset.doBone)

	layerBox = LM.GUI.RadioButton("Cycle selected layer position")
	l:AddChild(layerBox, LM.GUI.ALIGN_LEFT)
	--d.layerBox:SetValue(DS_CycleOffset.doLayer)
	l:PushH()
		l:PushV()
	l:AddChild(LM.GUI.StaticText("Last frame in cycle is a:"))
	linearBox = LM.GUI.RadioButton("Linear keyframe")
	l:AddChild(linearBox, LM.GUI.ALIGN_LEFT)
	
	smoothBox = LM.GUI.RadioButton("Smooth keyframe")
	l:AddChild(smoothBox, LM.GUI.ALIGN_LEFT)
	smoothBox:SetValue(true)
	
	stepBox = LM.GUI.RadioButton("Step keyframe")
	l:AddChild(stepBox, LM.GUI.ALIGN_LEFT)
	
	easeBox = LM.GUI.RadioButton("Ease keyframe")
	l:AddChild(easeBox, LM.GUI.ALIGN_LEFT)
	l:Pop()
	l:Pop()
	return d
end

function DS_Dialog:UpdateWidgets()
	self.loopTimes:SetValue(DS_CycleOffset.LoopTimes)
	if (self.moho.layer:LayerType() ~= MOHO.LT_BONE) then
		boneBox:Enable(false)
		layerBox:SetValue(true)
	else
		boneBox:Enable(true)
		layerBox:SetValue(false)
		boneBox:SetValue(true)
	end
end


function DS_Dialog:OnOK()
DS_CycleOffset.doBone=boneBox:Value()
DS_CycleOffset.doLayer=layerBox:Value()
DS_CycleOffset.LoopTimes = self.loopTimes:Value()
	if (linearBox:Value()) then
		DS_CycleOffset.LastInterp = 0
	elseif (smoothBox:Value()) then
		DS_CycleOffset.LastInterp = 1
	elseif (easeBox:Value()) then
		DS_CycleOffset.LastInterp = 2
	elseif (stepBox:Value()) then
		DS_CycleOffset.LastInterp = 3
	end
end

-- **************************************************
-- The guts of this script
-- **************************************************


function DS_CycleOffset:Run(moho)


local endFrame = moho.document:EndFrame()
local theBone = -1
local Interpolation = 0
local AbsoluteCycle = 0
local RelativeCycle = 0
local duration = 0
local layer = moho.layer
local CycleToThis = 0
local v1 = LM.Vector2:new_local()
local v2 = LM.Vector2:new_local()
local v3 = LM.Vector2:new_local()
local v4 = LM.Vector2:new_local()
local v5 = LM.Vector2:new_local()
local Interp = -1
local val1 = -1
local val2 = -1
local ch = nil

local dlog = DS_Dialog:new(moho)
	if (dlog:DoModal() == LM.GUI.MSG_CANCEL) then
		return
	end

	moho.document:PrepUndo(moho.layer)
	moho.document:SetDirty()

if (self.doBone) then -- here be bone mode
		if (skel == nil) then
				return false
		end

		local skel = moho:Skeleton()
		
		for i = 0, skel:CountBones() - 1 do --For every bone do this
			theBone=skel:Bone(i)
			if (theBone.fSelected) then 
			break
			end
		end
	
	ch = theBone.fAnimPos
	local v1 = LM.Vector2:new_local()
	local v2 = LM.Vector2:new_local()
	local v3 = LM.Vector2:new_local()
	local v4 = LM.Vector2:new_local()
	local v5 = LM.Vector2:new_local()
else
	ch = layer.fTranslation
	local v1 = LM.Vector3:new_local()
	local v2 = LM.Vector3:new_local()
	local v3 = LM.Vector3:new_local()
	local v4 = LM.Vector3:new_local()
	local v5 = LM.Vector3:new_local()
end
	duration = ch:Duration()
	
	if (ch:GetKeyInterpMode(duration)== 5) then
	local lastFrame = duration + layer:TotalTimingOffset()
		Interpolation, RelativeCycle, AbsoluteCycle = ch:GetKeyInterp(duration, Interpolation,RelativeCycle, AbsoluteCycle);
		
		-------------------------------- Calculate what frame we want to cycle to
		if (AbsoluteCycle == (-1)) then --If the cycle is not set to an absolute keyframe
			CycleToThis = (duration - RelativeCycle) - 1
		else
			CycleToThis = (AbsoluteCycle + layer:TotalTimingOffset()) - 1
		end
		
		local FrameAmount = duration - CycleToThis
		endFrame = (lastFrame+1)+(self.LoopTimes*FrameAmount)

		--Fix last frame
		
		ch:SetKeyInterp(lastFrame, self.LastInterp, -1, -1)
		for f = lastFrame+1, endFrame do
			local loopCount = math.ceil((f-CycleToThis)/FrameAmount)
			local subtractAmount = FrameAmount * (loopCount-1)
			if (ch:HasKey(f-subtractAmount)) then
				--First we set the correct value
				v1 = ch:GetValue(f-subtractAmount) -- Get position from the loop
				v2 = ch:GetValue(duration) -- Get position from the end of the loop
				v3 = ch:GetValue(CycleToThis)
				v4 = (v2 - v3) * (loopCount-1)
				v5 = v1 + v4
				ch:SetValue(f, v5)
				--Then we set the correct interpolation
				if (ch.GetKeyInterpMode ~= nil) then
				Interp, val1, val2 = ch:GetKeyInterp(f-subtractAmount, Interp,val1, val2);
				end
				ch:SetKeyInterp(f, Interp, val1, val2)
			end
		end
	
	else
		LM.GUI.Alert(LM.GUI.ALERT_INFO, 'Last keyframe is not a Cycle.')
	end

end