
-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "DS_export_hitfilm"

-- **************************************************
-- General information about this script
-- **************************************************

DS_export_hitfilm = {}
function DS_export_hitfilm:Name()
	return "Export to Hitfilm 2 comp"
end

function DS_export_hitfilm:Version()
	return "0.1"
end

function DS_export_hitfilm:Description()
	return "Export to Hitfilm 2 comp"
end

function DS_export_hitfilm:Creator()
	return "dauid.com"
end

function DS_export_hitfilm:UILabel()
	return("Export to Hitfilm 2 comp")
end


-- **************************************************
-- The guts of this script
-- **************************************************


function DS_export_hitfilm:OnMouseDown(moho, mouseEvent)
	self:Run(moho)
end
math.randomseed( os.time())
function DS_export_hitfilm:GUID()
	local chars = {"0","1","2","3","4","5","6","7","8","9","a","b","c","d","e","f"}
	local udid = ""
 
	 
	 for i = 1, 8 do
		
		udid = udid..chars[math.random(1,16)]
	 end
	 udid = udid.."-"
	  for i = 1, 4 do
		udid = udid..chars[math.random(1,16)]
	 end
	  udid = udid.."-"
	  for i = 1, 4 do
		udid = udid..chars[math.random(1,16)]
	 end
	  udid = udid.."-"
	  for i = 1, 4 do
		udid = udid..chars[math.random(1,16)]
	 end
	  udid = udid.."-"
	  for i = 1, 12 do
		udid = udid..chars[math.random(1,16)]
	 end
	return udid
end

function DS_export_hitfilm:Run(moho)

local path = LM.GUI.SaveFile("Select Data File")
	if (path == "") then
		return
	end
	
		local f = io.open(path..".hfcs", "w")

	if (f == nil) then
		return
	end

local width = moho.document:Width()
local height = moho.document:Height()
local aspect = moho.document:AspectRatio()
local newX = (moho.document:Width()/2)
local newY = moho.document:Height()/2
local newZ = moho.document:Height()/2


local fps = moho.document:Fps()
local startframe = moho.document:StartFrame()
local endframe = moho.document:EndFrame()
local campos= LM.Vector3:new_local()
local pantilt = LM.Vector2:new_local()

local compName = "Anime Studio export"
local compID = self:GUID()
local camID = self:GUID()
local camName = "Anime Studio Camera"

f:write("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n")
f:write("<BiffCompositeShot>\n")
	f:write("\t<Assets>\n")
	f:write("\t</Assets>\n")
		f:write("\t\t<CompositionAsset Version=\"4\">\n")
			f:write("\t\t\t<ID>"..compID.."</ID>\n")
			f:write("\t\t\t<Name>"..compName.."</Name>\n")
			f:write("\t\t\t<ParentFolderID>00000000-0000-0000-0000-000000000000</ParentFolderID>\n")
			f:write("\t\t\t<CTI>0</CTI>\n") --Scrubber position
			f:write("\t\t\t<InPoint>"..startframe.."</InPoint>\n")
			f:write("\t\t\t<OutPoint>"..endframe.."</OutPoint>\n")
			f:write("\t\t\t<TimelineZoom>0</TimelineZoom>\n")
			f:write("\t\t\t<SplitterPosition>440</SplitterPosition>\n")
			f:write("\t\t\t<TimelineTimeFormat>1000</TimelineTimeFormat>\n")
			f:write("\t\t\t<TimelineSnapMode>1000</TimelineSnapMode>\n")
			f:write("\t\t\t<AudioVideoSettings Version=\"0\">\n")
				f:write("\t\t\t\t<FrameCount>"..endframe-startframe.."</FrameCount>\n")
				f:write("\t\t\t\t<AudioSampleRate>48000</AudioSampleRate>\n")
				f:write("\t\t\t\t<Width>"..width.."</Width>\n")
				f:write("\t\t\t\t<Height>"..height.."</Height>\n")
				f:write("\t\t\t\t<Fields>0</Fields>\n")
				f:write("\t\t\t\t<PAR>0</PAR>\n")
				f:write("\t\t\t\t<PARCustom>1</PARCustom>\n")
				f:write("\t\t\t\t<FrameRate>"..fps.."</FrameRate>\n")
			f:write("\t\t\t</AudioVideoSettings>\n")
			
			f:write("\t\t\t<Layers>\n")
				f:write("\t\t\t\t<CameraLayer Version=\"1\">\n")
					f:write("\t\t\t\t\t<Dimensions>1</Dimensions>\n")
					f:write("\t\t\t\t\t<HasDoF>0</HasDoF>\n")
					f:write("\t\t\t\t\t<AutoOrient>0</AutoOrient>\n")
					f:write("\t\t\t\t\t<AutoOrientPathAxis>3</AutoOrientPathAxis>\n")
					f:write("\t\t\t\t\t<NearClip>0.100000001</NearClip>\n")
					f:write("\t\t\t\t\t<FarClip>100000</FarClip>\n")
					
					f:write("\t\t\t\t\t<LayerBase Version=\"0\">\n")
						f:write("\t\t\t\t\t\t<ID>"..camID.."</ID>\n")
						f:write("\t\t\t\t\t\t<Name>"..camName.."</Name>\n")
						f:write("\t\t\t\t\t\t<CompID>"..compID.."</CompID>\n")
						f:write("\t\t\t\t\t\t<ParentLayerID>00000000-0000-0000-0000-000000000000</ParentLayerID>\n")
						f:write("\t\t\t\t\t\t<StartFrame>"..startframe.."</StartFrame>\n")
						f:write("\t\t\t\t\t\t<EndFrame>"..endframe.."</EndFrame>\n")
						f:write("\t\t\t\t\t\t<BlendMode>0</BlendMode>\n")
						f:write("\t\t\t\t\t\t<Visible>1</Visible>\n")
						f:write("\t\t\t\t\t\t<Muted>0</Muted>\n")
						f:write("\t\t\t\t\t\t<Locked>0</Locked>\n")
						f:write("\t\t\t\t\t\t<MotionBlurOn>0</MotionBlurOn>\n")
						
						f:write("\t\t\t\t\t\t<PropertyManager Version=\"1\">\n")
						
						----------------------------
						-- Position of camera
						----------------------------
							f:write("\t\t\t\t\t\t\t<position Type=\"0\" Spatial=\"1\">\n")
								--Camera position
								local campos = moho.document.fCameraTrack:GetValue(startframe)
								if (aspect >0) then
									campos.x = (campos.x) * newY
									campos.y = (campos.y) * newY
									campos.z = (campos.z) *newZ
								else
									campos.x = (campos.x) * newX
									campos.y = (campos.y) * newX
									campos.z = (campos.z) *newX
								end
								
								f:write("\t\t\t\t\t\t\t\t<Default V=\"1\"><p3 X=\""..campos.x.."\" Y=\""..campos.y.."\" Z=\""..campos.z.."\"/></Default>\n")
								f:write("\t\t\t\t\t\t\t\t<Animation>\n")
								
								for frame = startframe, endframe do
								
								--Camera position
								local campos = moho.document.fCameraTrack:GetValue(frame)
								if (aspect >0) then
									campos.x = (campos.x) * newY
									campos.y = (campos.y) * newY
									campos.z = (campos.z) *newZ
								else
									campos.x = (campos.x) * newX
									campos.y = (campos.y) * newX
									campos.z = (campos.z) *newX
								end

								local thetime = ((frame-startframe)/fps)*1000
								f:write("\t\t\t\t\t\t\t\t\t<Key V=\"1\" Ti=\"".. thetime .."\" Tp=\"1\">\n")
								f:write("\t\t\t\t\t\t\t\t\t<Vl V=\"1\">\n")
									f:write("\t\t\t\t\t\t\t\t\t\t<p3 X=\""..campos.x.."\" Y=\""..campos.y.."\" Z=\""..campos.z.."\"/>\n")
								f:write("\t\t\t\t\t\t\t\t\t</Vl>\n")
								f:write("\t\t\t\t\t\t\t\t\t</Key>\n")
								---
								end
								
								f:write("\t\t\t\t\t\t\t\t</Animation>\n")
				
								
							f:write("\t\t\t\t\t\t\t</position>\n")
						----------------------------
						-- //Position of camera
						----------------------------
							
							f:write("\t\t\t\t\t\t\t<target Type=\"0\" Spatial=\"1\">\n")
								f:write("\t\t\t\t\t\t\t<Default V=\"1\"><p3 X=\"0\" Y=\"0\" Z=\"0\"/></Default>\n")
							f:write("\t\t\t\t\t\t\t</target>\n")
							
							f:write("\t\t\t\t\t\t\t<orientation Type=\"0\" Spatial=\"0\">\n")
								f:write("\t\t\t\t\t\t\t<Default V=\"1\"><or X=\"0\" Y=\"0\" Z=\"0\"/></Default>\n")
							f:write("\t\t\t\t\t\t\t</orientation>\n")
							
							f:write("\t\t\t\t\t\t\t<blurDoF Type=\"0\" Spatial=\"0\">\n")
								f:write("\t\t\t\t\t\t\t<Default V=\"1\">\n")
								f:write("\t\t\t\t\t\t\t<fl>100</fl>\n")
								f:write("\t\t\t\t\t\t\t</Default>\n")
							f:write("\t\t\t\t\t\t\t</blurDoF>\n")
							
							f:write("\t\t\t\t\t\t\t<aperture Type=\"0\" Spatial=\"0\">\n")
								f:write("\t\t\t\t\t\t\t<Default V=\"1\">\n")
									f:write("\t\t\t\t\t\t\t<fl>17.7199993</fl>\n")
								f:write("\t\t\t\t\t\t\t</Default>\n")
							f:write("\t\t\t\t\t\t\t</aperture>\n")
							
							local pantilt = moho.document.fCameraPanTilt:GetValue(startframe)
							f:write("\t\t\t\t\t\t\t<rotationX Type=\"0\" Spatial=\"0\">\n")
								f:write("\t\t\t\t\t\t\t<Default V=\"1\">\n")
									f:write("\t\t\t\t\t\t\t<fl>"..math.deg(pantilt.x)*(-1).."</fl>\n")
								f:write("\t\t\t\t\t\t\t</Default>\n")
								
								f:write("\t\t\t\t\t\t\t<Animation>\n")
									for frame = startframe, endframe do
										pantilt = moho.document.fCameraPanTilt:GetValue(frame)
										local thetime = ((frame-startframe)/fps)*1000
										f:write("\t\t\t\t\t\t\t\t\t<Key V=\"1\" Ti=\"".. thetime .."\" Tp=\"1\">\n")
										f:write("\t\t\t\t\t\t\t\t\t<Vl V=\"1\">\n")
											f:write("\t\t\t\t\t\t\t<fl>"..math.deg(pantilt.x)*(-1).."</fl>\n")
										f:write("\t\t\t\t\t\t\t\t\t</Vl>\n")
										f:write("\t\t\t\t\t\t\t\t\t</Key>\n")
									end
								f:write("\t\t\t\t\t\t\t</Animation>\n")
								
							f:write("\t\t\t\t\t\t\t</rotationX>\n")
							----------------
							-- Zoom
							----------------
							local zoom = newZ/math.tan(math.pi/(moho.document.fCameraZoom:GetValue(startframe)*6))
							f:write("\t\t\t\t\t\t\t<zoom Type=\"0\" Spatial=\"0\">\n")
								f:write("\t\t\t\t\t\t\t<Default V=\"1\">\n")
									f:write("\t\t\t\t\t\t\t<fl>"..zoom.."</fl>\n")
								f:write("\t\t\t\t\t\t\t</Default>\n")
								
								f:write("\t\t\t\t\t\t\t<Animation>\n")
									for frame = startframe, endframe do
										zoom = newZ/math.tan(math.pi/(moho.document.fCameraZoom:GetValue(frame)*6))
										local thetime = ((frame-startframe)/fps)*1000
										f:write("\t\t\t\t\t\t\t\t\t<Key V=\"1\" Ti=\"".. thetime .."\" Tp=\"1\">\n")
										f:write("\t\t\t\t\t\t\t\t\t<Vl V=\"1\">\n")
											f:write("\t\t\t\t\t\t\t<fl>"..zoom.."</fl>\n")
										f:write("\t\t\t\t\t\t\t\t\t</Vl>\n")
										f:write("\t\t\t\t\t\t\t\t\t</Key>\n")
									end
								f:write("\t\t\t\t\t\t\t</Animation>\n")
								
							f:write("\t\t\t\t\t\t\t</zoom>\n")
							---------------
							-- //Zoom
							---------------
							f:write("\t\t\t\t\t\t\t<rotationY Type=\"0\" Spatial=\"0\">\n")
								f:write("\t\t\t\t\t\t\t<Default V=\"1\">\n")
									f:write("\t\t\t\t\t\t\t<fl>"..math.deg(pantilt.y)*(-1).."</fl>\n")
								f:write("\t\t\t\t\t\t\t</Default>\n")
								
								f:write("\t\t\t\t\t\t\t<Animation>\n")
									for frame = startframe, endframe do
										pantilt = moho.document.fCameraPanTilt:GetValue(frame)
										local thetime = ((frame-startframe)/fps)*1000
										f:write("\t\t\t\t\t\t\t\t\t<Key V=\"1\" Ti=\"".. thetime .."\" Tp=\"1\">\n")
										f:write("\t\t\t\t\t\t\t\t\t<Vl V=\"1\">\n")
											f:write("\t\t\t\t\t\t\t<fl>"..math.deg(pantilt.y)*(-1).."</fl>\n")
										f:write("\t\t\t\t\t\t\t\t\t</Vl>\n")
										f:write("\t\t\t\t\t\t\t\t\t</Key>\n")
									end
								f:write("\t\t\t\t\t\t\t</Animation>\n")
								
							f:write("\t\t\t\t\t\t\t</rotationY>\n")
							
							f:write("\t\t\t\t\t\t\t<focusDistance Type=\"0\" Spatial=\"0\">\n")
								f:write("\t\t\t\t\t\t\t<Default V=\"1\">\n")
									f:write("\t\t\t\t\t\t\t<fl>"..zoom.."</fl>\n")
								f:write("\t\t\t\t\t\t\t</Default>\n")
							f:write("\t\t\t\t\t\t\t</focusDistance>\n")
							
							local camroll = math.deg(moho.document.fCameraRoll:GetValue(startframe))
							f:write("\t\t\t\t\t\t\t<rotationZ Type=\"0\" Spatial=\"0\">\n")
								f:write("\t\t\t\t\t\t\t<Default V=\"1\">\n")
									f:write("\t\t\t\t\t\t\t<fl>"..camroll.."</fl>\n")
								f:write("\t\t\t\t\t\t\t</Default>\n")
								
								f:write("\t\t\t\t\t\t\t<Animation>\n")
									for frame = startframe, endframe do
										camroll = math.deg(moho.document.fCameraRoll:GetValue(frame))
										local thetime = ((frame-startframe)/fps)*1000
										f:write("\t\t\t\t\t\t\t\t\t<Key V=\"1\" Ti=\"".. thetime .."\" Tp=\"1\">\n")
										f:write("\t\t\t\t\t\t\t\t\t<Vl V=\"1\">\n")
											f:write("\t\t\t\t\t\t\t<fl>"..camroll.."</fl>\n")
										f:write("\t\t\t\t\t\t\t\t\t</Vl>\n")
										f:write("\t\t\t\t\t\t\t\t\t</Key>\n")
									end
								f:write("\t\t\t\t\t\t\t</Animation>\n")
								
							f:write("\t\t\t\t\t\t\t</rotationZ>\n")
							
							
						f:write("\t\t\t\t\t\t</PropertyManager>\n")
						
					f:write("\t\t\t\t\t</LayerBase>\n")
				f:write("\t\t\t\t</CameraLayer>\n")
				
				----------------------------------------------------------------------------
				-- Layers
				----------------------------------------------------------------------------
				local numlayers = moho.document:CountLayers() --Do top layers
				for l = 0, numlayers - 1 do
				local layer = moho.document:Layer(l)
				f:write("\t\t\t\t<PointLayer Version=\"0\">\n")
					f:write("\t\t\t\t\t<Dimensions>1</Dimensions>\n")
					f:write("\t\t\t\t\t<LayerBase Version=\"0\">\n")
					f:write("\t\t\t\t\t<ID>".. self:GUID() .."</ID>\n")
					f:write("\t\t\t\t\t<Name>".. layer:Name() .."</Name>\n")
					f:write("\t\t\t\t\t<CompID>".. compID .."</CompID>\n")
					f:write("\t\t\t\t\t<ParentLayerID>00000000-0000-0000-0000-000000000000</ParentLayerID>\n")
					f:write("\t\t\t\t\t<StartFrame>".. startframe .."</StartFrame>\n")
					f:write("\t\t\t\t\t<EndFrame>".. endframe .."</EndFrame>\n")
					f:write("\t\t\t\t\t<BlendMode>0</BlendMode>\n")
					f:write("\t\t\t\t\t<Visible>1</Visible>\n")
					f:write("\t\t\t\t\t<Muted>0</Muted>\n")
					f:write("\t\t\t\t\t<Locked>0</Locked>\n")
					f:write("\t\t\t\t\t<MotionBlurOn>0</MotionBlurOn>\n")
						f:write("\t\t\t\t\t\t<PropertyManager Version=\"1\">\n")
						
						---------
						-- Rot Z
						---------
						f:write("\t\t\t\t\t\t<rotationZ Type=\"0\" Spatial=\"0\">\n")
						f:write("\t\t\t\t\t\t<Default V=\"1\">\n")
							local rotation = math.deg(layer.fRotationZ:GetValue(startframe))
							f:write("\t\t\t\t\t\t\t<fl>".. rotation*(-1) .."</fl>\n")
						f:write("\t\t\t\t\t\t</Default>\n")

						f:write("\t\t\t\t\t\t<Animation>\n")
						for frame = startframe, endframe do
							local rotation = math.deg(layer.fRotationZ:GetValue(frame))
							local thetime = ((frame-startframe)/fps)*1000
							f:write("\t\t\t\t\t\t\t\t\t<Key V=\"1\" Ti=\"".. thetime .."\" Tp=\"1\">\n")
							f:write("\t\t\t\t\t\t\t\t\t<Vl V=\"1\">\n")
								f:write("\t\t\t\t\t\t\t<fl>".. rotation*(-1) .."</fl>\n")
							f:write("\t\t\t\t\t\t\t\t\t</Vl>\n")
							f:write("\t\t\t\t\t\t\t\t\t</Key>\n")
						end
						f:write("\t\t\t\t\t\t</Animation>\n")

						f:write("\t\t\t\t\t\t</rotationZ>\n")
						--------
						--//Rot Z
						--------
						
						---------
						-- Anchor
						---------
						f:write("\t\t\t\t\t\t<anchorPoint Type=\"0\" Spatial=\"1\">\n")
						f:write("\t\t\t\t\t\t<Default V=\"1\">\n")
							local anchor = layer:Origin()
								if (aspect >0) then
									anchor.x = ((anchor.x) * newY)--+(newX-newY)
									anchor.y = ((anchor.y)) * newY
								else
									anchor.x = ((anchor.x) * newX)
									anchor.y = ((anchor.y)) * newX --+ (newY-newX)
								end
							f:write("\t\t\t\t\t\t\t<p3 X=\"".. anchor.x .."\" Y=\"".. anchor.y .."\" Z=\"".. 0 .."\" />\n")
						f:write("\t\t\t\t\t\t</Default>\n")
						f:write("\t\t\t\t\t\t</anchorPoint>\n")
						--------
						--//Anchor
						--------

						---------
						-- Pos
						---------
						f:write("\t\t\t\t\t\t<position Type=\"0\" Spatial=\"1\">\n")
						f:write("\t\t\t\t\t\t<Default V=\"1\">\n")
							local translation = layer.fTranslation:GetValue(startframe)
							local anchor = layer:Origin()
							if (aspect >0) then
								translation.x = (translation.x+anchor.x) * newY
								translation.y = (translation.y+anchor.y) * newY
								translation.z = (translation.z)*newZ
							else
								translation.x = (translation.x+anchor.x)* newX
								translation.y = (translation.y+anchor.y) * newX
								translation.z = (translation.z)*newX
							end
							f:write("\t\t\t\t\t\t\t<p3 X=\"".. translation.x .."\" Y=\"".. translation.y .."\" Z=\"".. translation.z .."\" />\n")
						f:write("\t\t\t\t\t\t</Default>\n")
					
						f:write("\t\t\t\t\t\t<Animation>\n")
						for frame = startframe, endframe do
							local translation = layer.fTranslation:GetValue(frame)
							if (aspect >0) then
								translation.x = (translation.x+anchor.x) * newY
								translation.y = (translation.y+anchor.y) * newY
								translation.z = (translation.z)*newZ
							else
								translation.x = (translation.x+anchor.x) * newX
								translation.y = (translation.y+anchor.y) * newX
								translation.z = (translation.z)*newX
							end
							local thetime = ((frame-startframe)/fps)*1000
							f:write("\t\t\t\t\t\t\t\t\t<Key V=\"1\" Ti=\"".. thetime .."\" Tp=\"1\">\n")
							f:write("\t\t\t\t\t\t\t\t\t<Vl V=\"1\">\n")
								f:write("\t\t\t\t\t\t\t<p3 X=\"".. translation.x .."\" Y=\"".. translation.y .."\" Z=\"".. translation.z .."\" />\n")
							f:write("\t\t\t\t\t\t\t\t\t</Vl>\n")
							f:write("\t\t\t\t\t\t\t\t\t</Key>\n")
						end
						f:write("\t\t\t\t\t\t</Animation>\n")
				
						f:write("\t\t\t\t\t\t</position>\n")
						--------
						--//Pos
						--------
						---------
						-- Scale
						---------
						f:write("\t\t\t\t\t\t<scale Type=\"0\" Spatial=\"1\">\n")
						f:write("\t\t\t\t\t\t<Default V=\"1\">\n")
							local scale = layer.fScale:GetValue(startframe)
							f:write("\t\t\t\t\t\t\t<sc X=\"".. scale.x*100 .."\" Y=\"".. scale.y*100 .."\" Z=\"".. scale.z*100 .."\" />\n")
						f:write("\t\t\t\t\t\t</Default>\n")
					
						f:write("\t\t\t\t\t\t<Animation>\n")
						for frame = startframe, endframe do
							
							local thetime = ((frame-startframe)/fps)*1000
							f:write("\t\t\t\t\t\t\t\t\t<Key V=\"1\" Ti=\"".. thetime .."\" Tp=\"1\">\n")
							f:write("\t\t\t\t\t\t\t\t\t<Vl V=\"1\">\n")
								scale = layer.fScale:GetValue(frame)
								f:write("\t\t\t\t\t\t\t<sc X=\"".. scale.x*100 .."\" Y=\"".. scale.y*100 .."\" Z=\"".. scale.z*100 .."\" />\n")
							f:write("\t\t\t\t\t\t\t\t\t</Vl>\n")
							f:write("\t\t\t\t\t\t\t\t\t</Key>\n")
						end
						f:write("\t\t\t\t\t\t</Animation>\n")
					
						f:write("\t\t\t\t\t\t</scale>\n")
						--------
						--//Scale
						--------

						---------
						-- Scale linked
						---------
						f:write("\t\t\t\t\t\t<scaleLinked Type=\"0\" Spatial=\"0\">\n")
						f:write("\t\t\t\t\t\t<Default V=\"1\">\n")
							f:write("\t\t\t\t\t\t\t<b>1</b>\n")
						f:write("\t\t\t\t\t\t</Default>\n")
						
						f:write("\t\t\t\t\t\t</scaleLinked>\n")
						--------
						--//Scale linked
						--------
						---------
						-- Orientation
						---------
						f:write("\t\t\t\t\t\t<orientation Type=\"0\" Spatial=\"0\">\n")
						f:write("\t\t\t\t\t\t<Default V=\"1\">\n")
							f:write("\t\t\t\t\t\t\t<or X=\"0\" Y=\"0\" Z=\"0\" />\n")
						f:write("\t\t\t\t\t\t</Default>\n")
						
						f:write("\t\t\t\t\t\t</orientation>\n")
						--------
						--//Orientation
						--------
						---------
						-- Rot X
						---------
						f:write("\t\t\t\t\t\t<rotationX Type=\"0\" Spatial=\"0\">\n")
						f:write("\t\t\t\t\t\t<Default V=\"1\">\n")
							local rotation = math.deg(layer.fRotationZ:GetValue(startframe))
							f:write("\t\t\t\t\t\t\t<fl>".. rotation .."</fl>\n")
						f:write("\t\t\t\t\t\t</Default>\n")
					
						f:write("\t\t\t\t\t\t<Animation>\n")
						for frame = startframe, endframe do
							local rotation = math.deg(layer.fRotationX:GetValue(frame))
							local thetime = ((frame-startframe)/fps)*1000
							f:write("\t\t\t\t\t\t\t\t\t<Key V=\"1\" Ti=\"".. thetime .."\" Tp=\"1\">\n")
							f:write("\t\t\t\t\t\t\t\t\t<Vl V=\"1\">\n")
								f:write("\t\t\t\t\t\t\t<fl>".. rotation .."</fl>\n")
							f:write("\t\t\t\t\t\t\t\t\t</Vl>\n")
							f:write("\t\t\t\t\t\t\t\t\t</Key>\n")
						end
						f:write("\t\t\t\t\t\t</Animation>\n")
					
						f:write("\t\t\t\t\t\t</rotationX>\n")
						--------
						--//Rot X
						--------
						
						---------
						-- Rot Y
						---------
						f:write("\t\t\t\t\t\t<rotationY Type=\"0\" Spatial=\"0\">\n")
						f:write("\t\t\t\t\t\t<Default V=\"1\">\n")
							local rotation = math.deg(layer.fRotationY:GetValue(startframe))
							f:write("\t\t\t\t\t\t\t<fl>".. rotation*(-1) .."</fl>\n")
						f:write("\t\t\t\t\t\t</Default>\n")
						
						f:write("\t\t\t\t\t\t<Animation>\n")
						for frame = startframe, endframe do
							local rotation = math.deg(layer.fRotationY:GetValue(frame))
							local thetime = ((frame-startframe)/fps)*1000
							f:write("\t\t\t\t\t\t\t\t\t<Key V=\"1\" Ti=\"".. thetime .."\" Tp=\"1\">\n")
							f:write("\t\t\t\t\t\t\t\t\t<Vl V=\"1\">\n")
								f:write("\t\t\t\t\t\t\t<fl>".. rotation*(-1) .."</fl>\n")
							f:write("\t\t\t\t\t\t\t\t\t</Vl>\n")
							f:write("\t\t\t\t\t\t\t\t\t</Key>\n")
						end
						f:write("\t\t\t\t\t\t</Animation>\n")
					
						f:write("\t\t\t\t\t\t</rotationY>\n")
						--------
						--//Rot Y
						--------

						f:write("\t\t\t\t\t\t</PropertyManager>\n")
					f:write("\t\t\t\t\t</LayerBase>\n")
				f:write("\t\t\t\t</PointLayer>\n")
				end
				----------------------------------------------------------------------------
				-- //Layers
				----------------------------------------------------------------------------
			f:write("\t\t\t</Layers>\n")
			
		f:write("\t\t</CompositionAsset>\n")
	
f:write("</BiffCompositeShot>\n")

f:close() --Close the file
end