-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "DS_ZposAndScale"

-- **************************************************
-- General information about this script
-- **************************************************

DS_ZposAndScale = {}
function DS_ZposAndScale:Name()
	return "DS_ZposAndScale"
end

function DS_ZposAndScale:Version()
	return "0.1"
end

function DS_ZposAndScale:Description()
	return "Offset a cycle to move a walkcycle"
end

function DS_ZposAndScale:Creator()
	return "dauid.com"
end

function DS_ZposAndScale:UILabel()
	return("Z Position and Scale")
end
-- **************************************************
-- Recurring values
-- **************************************************
DS_ZposAndScale.newZ = 0
--************************menu
local DS_Dialog = {}

DS_Dialog.UPDATE = MOHO.MSG_BASE

function DS_Dialog:new(moho)
	local d = LM.GUI.SimpleDialog("Settings", DS_Dialog)
	local l = d:GetLayout()

	d.moho = moho
	l:PushH()
		l:PushV()
	l:AddChild(LM.GUI.StaticText("Move to Z: "))
	l:Pop()
		l:PushV()
	d.z = LM.GUI.TextControl(0, "0.0000", DS_Dialog.UPDATE, LM.GUI.FIELD_FLOAT)
	d.z:SetWheelInc(0.25)
	d.z:SetConstantMessages(true)
	l:AddChild(d.z)
	l:Pop()
	l:Pop()

	return d
end

function DS_Dialog:UpdateWidgets()
	self.z:SetValue(DS_ZposAndScale.newZ)
	
end


function DS_Dialog:OnOK()
DS_ZposAndScale.newZ=self.z:Value()
end

-- **************************************************
-- The guts of this script
-- **************************************************


function DS_ZposAndScale:Run(moho)

local dlog = DS_Dialog:new(moho)
	if (dlog:DoModal() == LM.GUI.MSG_CANCEL) then
		return
	end
	
	moho.document:PrepUndo(moho.layer)
	moho.document:SetDirty()
	
	local layer = moho.layer
	local transVal=layer.fTranslation:GetValue(moho.frame)
	local layerOrigin = LM.Vector2:new_local()
	local newOrigin = LM.Vector2:new_local()
	local camTrack = moho.document.fCameraTrack:GetValue(moho.frame)
	local theRatio = 1/camTrack.z
		
		
		transVal=layer.fTranslation:GetValue(moho.frame) 	-- Get the current position of the layer
		layerOrigin = layer:Origin() 						-- Get origin of layer
		newOrigin.x = transVal.x*(-1)						-- Get new origin by compensating for layer translation
		newOrigin.y = transVal.y*(-1)						
		layer:SetOrigin(newOrigin)
		
		local scaleVal=layer.fScale:GetValue(moho.frame) 			-- Get the current scale of the layer
		local originalScale = scaleVal
		local theZ = self.newZ - transVal.z
		
		scaleVal.x=((scaleVal.x*(1+((theZ*(-1))*(1/camTrack.z))))*(1/scaleVal.x)) --Goddamn formulas...
		scaleVal.y=((scaleVal.y*(1+((theZ*(-1))*(1/camTrack.z))))*(1/scaleVal.y))
		scaleVal.z=((scaleVal.z*(1+((theZ*(-1))*(1/camTrack.z))))*(1/scaleVal.z))
		
		
		layer.fScale:SetValue(moho.frame, scaleVal)
		
		transVal.z=self.newZ				-- Change only Z in the vector that holds the layer translation
		layer.fTranslation:SetValue(moho.frame, transVal) 	-- Move the layer according to transVal vector values
		
		
		moho:NewKeyframe(CHANNEL_LAYER_T)					-- And finally, add keyframes in the proper animation channels. S = Scale, T = Translation.
		moho:NewKeyframe(CHANNEL_LAYER_S)

end